/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controldeasistencias.views.constancia;

import controldeasistencias.Reportes.GenerarReportes;
import controldeasistencias.controllers.EmpleadoJpaController;
import controldeasistencias.controllers.ParametrosJpaController;
import controldeasistencias.entidades.Empleado;
import controldeasistencias.entidades.Parametros;
import controldeasistencias.utils.FuncionesUtiles;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import persistence.util.JpaUtil;

/**
 *
 * @author Administrador
 */
public class GenerarConstancia extends javax.swing.JDialog {

    /**
     * Creates new form GenerarConstancia
     */
    ParametrosJpaController parametrosController = new ParametrosJpaController(JpaUtil.getEntityManagerFactory());
    List<Parametros> listParametros;
    Parametros cedula;
    Parametros nombre;
    HashMap parametros = new HashMap();

    EmpleadoJpaController controller = new EmpleadoJpaController(JpaUtil.getEntityManagerFactory());
    List<Empleado> list;

    public GenerarConstancia(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        list = controller.findEmpleadoEntities();
        for (Empleado e : list) {
            listaEmpleados.addItem(e.getCedula() + " " + e.getNombres() + " " + e.getApellido());
        }
        
       
        //se cargan los parametros para generar la constancia.
        listParametros = parametrosController.findParametrosEntities();
        
        for (Parametros p : listParametros) {
            if (p.getClave().equals("CEDULA_DIRECTOR")) {
                cedula = p;
            }
            
            if (p.getClave().equals("NOMBRE_DIRECTOR")) {
                nombre = p;
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        listaEmpleados = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jButton1.setText("Generar Constancia");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addComponent(listaEmpleados, javax.swing.GroupLayout.PREFERRED_SIZE, 376, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(50, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(listaEmpleados, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton1))
                .addContainerGap(50, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        Empleado select =  (Empleado) list.get(listaEmpleados.getSelectedIndex());
       
        parametros.put("ci", select.getCedula());
        parametros.put("ci_doctor", cedula.getValor());
        parametros.put("nombre_doctor", nombre.getValor());
        parametros.put("fecha_emision", FuncionesUtiles.fechaEnLetras(new Date()));
       
        new Thread(new Runnable(){

            @Override
            public void run() {
                GenerarReportes.Generar("constancia_trabajo", parametros);
            }
        }).start();
        
        
        this.dispose(); 
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GenerarConstancia.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GenerarConstancia.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GenerarConstancia.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GenerarConstancia.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                GenerarConstancia dialog = new GenerarConstancia(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JComboBox listaEmpleados;
    // End of variables declaration//GEN-END:variables
}
